﻿-- Author      : Potdisc
-- Create Date : 3/23/2012 4:37:15 PM
-- LootFrame.lua
-- Gets info from MainFrame.lua and displays looting options for the player

local itemLooting = nil;
local update = true; -- used to check wether we have created the buttons already (if user changes the buttons after the first looting, then the code would otherwise just create new buttons instead of using the old ones)

function RCLootFrame_EventHandler(self, event, ...)
	
end
---------- setupLoot ----------------
-- Displays the loot frame for the user
-- Called by Mainframe.lua - sends all the info
-------------------------------------
function RCLootCouncil_LootFrame.setupLoot(itemTexture, iLink, ilvl, masterLooter, name)
	local db = RCLootCouncil:GetMLDB(true); -- get the db
	local buttonsDB = db.buttons
	if update then -- the first time; create the buttons
		------ Create buttons --------		
		local button = CreateFrame("Button", "$parentButton1", RcLootFrame, "RCLootFrame_Button"); -- Creates the first row
		button:SetID(1); -- Set the ID
		button:SetPoint("TOPLEFT", 68, -42) -- Set anchor
		local length = #(buttonsDB[1]["text"]) * 10 - 20; -- calculate length
		if length < 66 then length = 66 end -- minimun is 66px
		button:SetText(buttonsDB[1]["text"])
		button:SetWidth(length) -- set the length
		button:SetScript("OnClick", function() RCLootCouncil_LootFrame:onClick(1) end)
		for i = 2, db.numButtons do -- Create the rest of the buttons
			button = CreateFrame("Button", "$parentButton"..i, RcLootFrame, "RCLootFrame_Button");
			button:SetText(buttonsDB[i]["text"])
			button:SetScript("OnClick", function() RCLootCouncil_LootFrame:onClick(i) end)
			length = #(buttonsDB[i]["text"]) * 10 - 20
			if length < 66 then length = 66 end
			button:SetWidth(length)
			button:SetID(i);
			button:SetPoint("TOPLEFT", "$parentButton"..(i-1), "TOPRIGHT", 5, 0) -- Set the anchor to the previous button
			if buttonsDB[i]["text"] == "" then button:Hide() end
		end
	else -- the next time(s) only update the button's text and length
		for i = 1, db.numButtons do
			local length = #(buttonsDB[i]["text"]) * 10 - 20; -- calculate length
			if length < 66 then length = 66 end -- minimun is 66px
			local button = getglobal("RcLootFrameButton"..i)
			button:SetText(buttonsDB[i]["text"])
			button:SetWidth(length)
			if buttonsDB[i]["text"] ~= "" then button:Show() else button:Hide() end -- show/hide it if the user has updated it to
			if i ~= 1 then button:SetPoint("TOPLEFT", "RcLootFrameButton"..(i-1), "TOPRIGHT", 5, 0) end -- move the buttons over aswell
		end
	end
	local hoverWidth = #name * 10 - 40
	RcLootFrameHover2:SetWidth(hoverWidth) -- set the mouse over link to match the item name
	
	-- Get and set the lootFrame width
	local lootFrameWidth = 100;
	for i = 1, db.numButtons do
		if buttonsDB[i]["text"] ~= "" then
			lootFrameWidth = lootFrameWidth + getglobal("RcLootFrameButton"..i):GetWidth()
		end
	end
	if lootFrameWidth - 90 < hoverWidth then lootFrameWidth = hoverWidth + 150; end -- make sure the width doesn't get less than the length of the item
	RcLootFrame:SetWidth(lootFrameWidth)

	itemLooting = iLink;
	-- Setup all the rest
	RcLootFrameItemLabel:SetText(iLink);
	RcLootFrameItemLabel:SetFont("Fonts\\FRIZQT__.TTF", 16);
	RcLootFrameTexture:SetTexture(itemTexture);
	RcLootFrameIlvl:SetText("ilvl: "..ilvl);
	RcLootFrameIlvl:SetPoint("TOPRIGHT", "$parent", "TOPRIGHT", -2, -5)
	RcLootFrame:Show();
	update = false;
end

---------- ShowTooltip -------------
-- Shows the loot item's tooltip
------------------------------------
function RCLootCouncil_LootFrame.ShowTooltip()
	if itemLooting then
		GameTooltip:SetOwner(RcLootFrame, "ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(itemLooting)
		GameTooltip:Show()
	end

end

------------- toolMouseLeave ------------------------
-- Removes the tooltip when mouse leaves the area
-----------------------------------------------------
function RCLootCouncil_LootFrame.toolMouseLeave()
	GameTooltip:Hide()
end

---------- onClick ------------------
-- Sends user response to MasterLooter
-------------------------------------
function RCLootCouncil_LootFrame:onClick(response)
	RcLootFrame:Hide();
	itemLooting = nil;
	RCLootCouncil.handleResponse(response);	
end

----------- hide -------------------
-- Hides the loot frame 
------------------------------------
function RCLootCouncil_LootFrame.hide()
	if RcLootFrame:IsShown() then
		RcLootFrame:Hide()
		itemLooting = nil;
	end
end
